property pDirection, pMovementSpeed, pAnimationSpeed, pPositionX, pPositionY, pSpriteName, pAntChannel, pHealth, pMaxHealth, pFakeChannel, pMaxFrameNumber, pDoDeath, pDoShooting, pPlayerDisabled, pEnergy, pDestPositionX, pDestPositionY, pSelected, pState, pMoving, pTempX, pTempY, pACounter, pBCounter, pATimer, pReadyTaLaunch, pDaPath, pPathFind, pCurrentNode, pPray
global gCurrentLevel, gPlayer1, gPlayer2, gPlayer3, gEnemy1, gEnemy2, gEnemy3, gBombList, gInfluence, gTotalHealth, gTotalScore

on new me, antDirection, antSpeed, animationSpeed, posX, posY, spriteName, antChannel
  pMoving = 0
  pDirection = antDirection
  pMovementSpeed = antSpeed
  pAnimationSpeed = animationSpeed
  pPositionX = posX
  pPositionY = posY
  pTempX = posX
  pTempY = posY
  pSpriteName = spriteName
  pAntChannel = antChannel
  pHealth = 50
  pMaxHealth = 50
  pFakeChannel = 15
  pMaxFrameNumber = 2
  pDoDeath = 0
  pPlayerDisabled = 0
  pEnergy = 0
  pDestPositionX = posX
  pDestPositionY = posY
  pSelected = 0
  pPray = 0
  pState = 1
  pATimer = the ticks
  pReadyTaLaunch = 0
  pPathFind = 0
  sprite(pAntChannel).loc = point(pPositionX, pPositionY)
  pACounter = 0
  pBCounter = 0
  sprite(pAntChannel).locZ = pAntChannel
  return me
end

on setAntDeSelected me
  if not (pState = 3) then
    pReadyTaLaunch = 0
    if pDirection = 0 then
      pDirection = 1
    end if
    sprite(pAntChannel).member = pSpriteName & "_" & string(pDirection) & "_1"
  end if
  pSelected = 0
  sprite(60).loc = point(800, 800)
  sprite(61).loc = point(800, 800)
end

on setMaxHealth me, maxHealth
  pMaxHealth = maxHealth
end

on setHealth me, health
  pHealth = health
  if pSelected = 1 then
    sprite(61).width = 47 * pHealth / pMaxHealth
  end if
  if pHealth <= 0 then
    if pSelected = 1 then
      getNextSprite()
    end if
    if pState <> 3 then
      case pAntChannel of
        50:
          sprite(50).locZ = 50 - 7
          puppetSound(4, "kill player")
        51:
          sprite(51).locZ = 51 - 7
          puppetSound(4, "kill player")
        52:
          sprite(52).locZ = 52 - 7
          puppetSound(4, "kill player")
        53:
          sprite(53).locZ = 53 - 7
          puppetSound(5, "kill enemy")
        54:
          sprite(54).locZ = 54 - 7
          puppetSound(5, "kill enemy")
        55:
          sprite(55).locZ = 55 - 7
          puppetSound(5, "kill enemy")
      end case
    end if
    pHealth = 0
    sprite(pAntChannel).member = "dead_" & string(pDirection)
    sprite(pAntChannel).locZ = pAntChannel - 20
    pState = 3
    if (gPlayer1.pState = 3) and (gPlayer2.pState = 3) and (gPlayer3.pState = 3) then
      puppetSound(2, "lose")
      member("win/lose").text = "Try Again"
      member("TotalScore").text = "Your Score:" && string(gTotalScore)
      go(19)
    else
      if (gEnemy1.pState = 3) and (gEnemy2.pState = 3) and (gEnemy3.pState = 3) then
        if gCurrentLevel >= 3 then
          gTotalScore = gTotalScore + 10
          member("win/lose").text = "You Win!"
          member("ScoreDisplay").text = string(gTotalScore)
          member("TotalScore").text = "Your Score:" && string(gTotalScore)
          puppetSound(2, "win10")
          go(19)
        else
          puppetSound(2, "levelcomplete10")
          gTotalScore = gTotalScore + 10
          member("ScoreDisplay").text = string(gTotalScore)
          member("TotalScore").text = "Your Score:" && string(gTotalScore)
          go(34)
        end if
      end if
    end if
  end if
end

on getHealth me
  return pHealth
end

on setAntSelected me
  sprite(61).width = 47 * pHealth / pMaxHealth
  sprite(60).loc = point(sprite(pAntChannel).locH, sprite(pAntChannel).top - 6)
  sprite(61).loc = point(sprite(pAntChannel).locH, sprite(pAntChannel).top - 6)
  pSelected = 1
end

on getAntChannel me
  return pAntChannel
end

on setDestPosition me, dPosX, dPosY
  pDestPositionX = dPosX
  pDestPositionY = dPosY
end

on updateAnt me
  case pState of
    1:
      if (pAntChannel = 50) or (pAntChannel = 51) then
        exit
      end if
      if (pPositionX >= pDestPositionX) and (pPositionX <= (pDestPositionX + 10)) and (pPositionY >= pDestPositionY) and (pPositionY <= (pDestPositionY + 10)) then
        if pPathFind = 1 then
          pMoving = 1
          pDestPositionX = pDaPath[pCurrentNode][1] * 22
          pDestPositionY = pDaPath[pCurrentNode][2] * 22
          pCurrentNode = pCurrentNode + 1
          if pCurrentNode > count(pDaPath) then
            pPathFind = 0
            pMoving = 0
          end if
        else
          pMoving = 0
        end if
        if (pReadyTaLaunch = 1) and (pMoving = 0) then
          sprite(pAntChannel).member = pSpriteName & "Throwing_" & string(pDirection) & "_1"
        end if
      else
        if (pPositionX >= pDestPositionX) and (pPositionX <= (pDestPositionX + 10)) and (pDestPositionY < pPositionY) then
          setAntDirection(me, 1)
          moveAnt(me)
        else
          if (pDestPositionX > pPositionX) and (pPositionY >= pDestPositionY) and (pPositionY <= (pDestPositionY + 10)) then
            setAntDirection(me, 3)
            moveAnt(me)
          else
            if (pPositionX >= pDestPositionX) and (pPositionX <= (pDestPositionX + 10)) and (pDestPositionY > pPositionY) then
              setAntDirection(me, 5)
              moveAnt(me)
            else
              if (pDestPositionX < pPositionX) and (pPositionY >= pDestPositionY) and (pPositionY <= (pDestPositionY + 10)) then
                setAntDirection(me, 7)
                moveAnt(me)
              else
                if (pDestPositionX > pPositionX) and (pDestPositionY < pPositionY) then
                  setAntDirection(me, 2)
                  moveAnt(me)
                else
                  if (pDestPositionX > pPositionX) and (pDestPositionY > pPositionY) then
                    setAntDirection(me, 4)
                    moveAnt(me)
                  else
                    if (pDestPositionX < pPositionX) and (pDestPositionY > pPositionY) then
                      setAntDirection(me, 6)
                      moveAnt(me)
                    else
                      if (pDestPositionX < pPositionX) and (pDestPositionY < pPositionY) then
                        setAntDirection(me, 8)
                        moveAnt(me)
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
    2:
      doAttackSequence()
    3:
      doGetsHurt()
    4:
      doDyeSequence()
  end case
end

on moveplayer me, aDirection
  if pState = 3 then
    exit
  end if
  setAntDirection(me, aDirection)
  case aDirection of
    1:
      setAntPosition(me, pPositionX, pPositionY - pMovementSpeed)
    2:
      setAntPosition(me, pPositionX + pMovementSpeed, pPositionY - pMovementSpeed)
    3:
      setAntPosition(me, pPositionX + pMovementSpeed, pPositionY)
    4:
      setAntPosition(me, pPositionX + pMovementSpeed, pPositionY + pMovementSpeed)
    5:
      setAntPosition(me, pPositionX, pPositionY + pMovementSpeed)
    6:
      setAntPosition(me, pPositionX - pMovementSpeed, pPositionY + pMovementSpeed)
    7:
      setAntPosition(me, pPositionX - pMovementSpeed, pPositionY)
    8:
      setAntPosition(me, pPositionX - pMovementSpeed, pPositionY - pMovementSpeed)
  end case
end

on moveAnt me
  if pState = 3 then
    exit
  end if
  pTempX = pPositionX
  pTempY = pPositionY
  if pSelected = 1 then
    sprite(60).loc = point(sprite(pAntChannel).locH, sprite(pAntChannel).top - 6)
    sprite(61).loc = point(sprite(pAntChannel).locH, sprite(pAntChannel).top - 6)
  end if
  case pDirection of
    1:
      pPositionY = pPositionY - pMovementSpeed
    2:
      pPositionY = pPositionY - pMovementSpeed
      pPositionX = pPositionX + pMovementSpeed
    3:
      pPositionX = pPositionX + pMovementSpeed
    4:
      pPositionX = pPositionX + pMovementSpeed
      pPositionY = pPositionY + pMovementSpeed
    5:
      pPositionY = pPositionY + pMovementSpeed
    6:
      pPositionY = pPositionY + pMovementSpeed
      pPositionX = pPositionX - pMovementSpeed
    7:
      pPositionX = pPositionX - pMovementSpeed
    8:
      pPositionX = pPositionX - pMovementSpeed
      pPositionY = pPositionY - pMovementSpeed
  end case
  if pPositionX < 10 then
    pPositionX = 10
  end if
  if pPositionX > 430 then
    pPositionX = 430
  end if
  if pPositionY < 10 then
    pPositionY = 10
  end if
  if pPositionY > 430 then
    pPositionY = 430
  end if
  if the ticks > (pATimer + 15) then
    pATimer = the ticks
    stringLength = length(string(member(sprite(pAntChannel).member).name))
    currFrame = chars(string(member(sprite(pAntChannel).member).name), stringLength, stringLength)
    currFrame = integer(currFrame) + 1
    if currFrame > pMaxFrameNumber then
      currFrame = 1
    end if
    sprite(pAntChannel).member = chars(string(member(sprite(pAntChannel).member).name), 1, stringLength - 1) & string(currFrame)
  end if
  if (pAntChannel = 50) or (pAntChannel = 51) or (pAntChannel = 52) then
    sprite(13).loc = point(pPositionX, pPositionY)
    updateStage()
    if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
      case pDirection of
        1:
          pPositionY = pPositionY + pMovementSpeed
          pPositionY = pPositionY - pMovementSpeed
          pPositionX = pPositionX + pMovementSpeed
          sprite(13).loc = point(pPositionX, pPositionY)
          updateStage()
          if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
            pPositionY = pPositionY + pMovementSpeed
            pPositionX = pPositionX - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            pPositionY = pPositionY - pMovementSpeed
            pPositionX = pPositionX - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            updateStage()
            if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
              pPositionY = pPositionY + pMovementSpeed
              pPositionX = pPositionX + pMovementSpeed
              sprite(13).loc = point(pPositionX, pPositionY)
              updateStage()
            end if
          end if
        3:
          pPositionX = pPositionX - pMovementSpeed
          pPositionY = pPositionY - pMovementSpeed
          pPositionX = pPositionX + pMovementSpeed
          sprite(13).loc = point(pPositionX, pPositionY)
          updateStage()
          if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
            pPositionY = pPositionY + pMovementSpeed
            pPositionX = pPositionX - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            pPositionY = pPositionY + pMovementSpeed
            pPositionX = pPositionX + pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            updateStage()
            if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
              pPositionY = pPositionY - pMovementSpeed
              pPositionX = pPositionX - pMovementSpeed
              sprite(13).loc = point(pPositionX, pPositionY)
              updateStage()
            end if
          end if
        5:
          pPositionY = pPositionY - pMovementSpeed
          pPositionY = pPositionY + pMovementSpeed
          pPositionX = pPositionX + pMovementSpeed
          sprite(13).loc = point(pPositionX, pPositionY)
          updateStage()
          if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
            pPositionY = pPositionY - pMovementSpeed
            pPositionX = pPositionX - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            pPositionY = pPositionY + pMovementSpeed
            pPositionX = pPositionX - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            updateStage()
            if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
              pPositionY = pPositionY - pMovementSpeed
              pPositionX = pPositionX + pMovementSpeed
              sprite(13).loc = point(pPositionX, pPositionY)
              updateStage()
            end if
          end if
        7:
          pPositionX = pPositionX + pMovementSpeed
          pPositionY = pPositionY - pMovementSpeed
          pPositionX = pPositionX - pMovementSpeed
          sprite(13).loc = point(pPositionX, pPositionY)
          updateStage()
          if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
            pPositionY = pPositionY + pMovementSpeed
            pPositionX = pPositionX + pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            pPositionY = pPositionY + pMovementSpeed
            pPositionX = pPositionX - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            updateStage()
            if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
              pPositionY = pPositionY - pMovementSpeed
              pPositionX = pPositionX + pMovementSpeed
              sprite(13).loc = point(pPositionX, pPositionY)
              updateStage()
            end if
          end if
        8:
          pPositionY = pPositionY + pMovementSpeed
          pPositionX = pPositionX + pMovementSpeed
          pPositionY = pPositionY - pMovementSpeed
          sprite(13).loc = point(pPositionX, pPositionY)
          updateStage()
          if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
            pPositionY = pPositionY + pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            pPositionX = pPositionX - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            updateStage()
            if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
              pPositionX = pPositionX + pMovementSpeed
              sprite(13).loc = point(pPositionX, pPositionY)
              updateStage()
            end if
          end if
        2:
          pPositionY = pPositionY + pMovementSpeed
          pPositionX = pPositionX - pMovementSpeed
          pPositionY = pPositionY - pMovementSpeed
          sprite(13).loc = point(pPositionX, pPositionY)
          updateStage()
          if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
            pPositionY = pPositionY + pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            pPositionX = pPositionX + pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            updateStage()
            if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
              pPositionX = pPositionX - pMovementSpeed
              sprite(13).loc = point(pPositionX, pPositionY)
              updateStage()
            end if
          end if
        6:
          pPositionY = pPositionY - pMovementSpeed
          pPositionX = pPositionX + pMovementSpeed
          pPositionY = pPositionY + pMovementSpeed
          sprite(13).loc = point(pPositionX, pPositionY)
          updateStage()
          if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
            pPositionY = pPositionY - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            pPositionX = pPositionX - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            updateStage()
            if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
              pPositionX = pPositionX + pMovementSpeed
              sprite(13).loc = point(pPositionX, pPositionY)
              updateStage()
            end if
          end if
        4:
          pPositionY = pPositionY - pMovementSpeed
          pPositionX = pPositionX - pMovementSpeed
          pPositionY = pPositionY + pMovementSpeed
          sprite(13).loc = point(pPositionX, pPositionY)
          updateStage()
          if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
            pPositionY = pPositionY - pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            pPositionX = pPositionX + pMovementSpeed
            sprite(13).loc = point(pPositionX, pPositionY)
            updateStage()
            if (sprite(13).intersects(7) = 1) or (sprite(13).intersects(8) = 1) then
              pPositionX = pPositionX - pMovementSpeed
              sprite(13).loc = point(pPositionX, pPositionY)
              updateStage()
            end if
          end if
      end case
      sprite(13).loc = point(pPositionX, pPositionY)
    end if
  end if
  sprite(pAntChannel).loc = point(pPositionX, pPositionY)
  sprite(15).loc = sprite(pAntChannel).loc
end

on setAntPosition me, posX, posY
  pPositionX = posX
  pPositionY = posY
  sprite(pAntChannel).locH = pPositionX
  sprite(pAntChannel).locV = pPositionY
end

on getAntPositionX me
  return pPositionX
end

on getAntPositionY me
  return pPositionY
end

on setAntDirection me, antDirection
  if (pDirection = antDirection) or (pState = 3) then
    exit
  end if
  pDirection = antDirection
  sprite(pAntChannel).member = pSpriteName & "_" & pDirection & "_1"
end

on getAntDirection me
  return pDirection
end

on doDeathAnimation me
end

on setEnergy me, theEnergy
  pEnergy = theEnergy
  if pEnergy > 48 then
    pEnergy = 48
  end if
  if pEnergy < 0 then
    pEnergy = 0
  end if
  sprite(282).right = sprite(282).left + pEnergy
end

on getEnergy me
  return pEnergy
end

on startBombThrow me, bType, bDistance
  if pState = 3 then
    exit
  end if
  pReadyTaLaunch = 0
  aChannel = 70
  found = 0
  repeat while found = 0
    if sprite(aChannel).puppet = 1 then
      aChannel = aChannel + 1
      next repeat
    end if
    found = 1
  end repeat
  puppetSound(1, "player throw")
  append(gBombList, new(script("BombScript"), pPositionX, pPositionY, bDistance, 10, bType, aChannel, pAntChannel))
  aAngle = gBombList[count(gBombList)].getAngle()
  if (aAngle >= 22) and (aAngle < 67) then
    setAntDirection(me, 8)
  else
    if (aAngle >= 67) and (aAngle < 112) then
      setAntDirection(me, 7)
    else
      if (aAngle >= 112) and (aAngle < 157) then
        setAntDirection(me, 6)
      else
        if (aAngle >= 157) and (aAngle < 202) then
          setAntDirection(me, 5)
        else
          if (aAngle >= 202) and (aAngle < 247) then
            setAntDirection(me, 4)
          else
            if (aAngle >= 247) and (aAngle < 292) then
              setAntDirection(me, 3)
            else
              if (aAngle >= 292) and (aAngle < 337) then
                setAntDirection(me, 2)
              else
                setAntDirection(me, 1)
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  sprite(pAntChannel).member = pSpriteName & "Throwing" & "_" & pDirection & "_2"
  pState = 2
  pACounter = 0
  repeat with counter = 1 to count(gBombList)
    if gBombList[counter].pState = 3 then
      deleteAt(gBombList, counter)
    end if
  end repeat
  pDirection = 0
end

on doAttackSequence me
  if pState = 3 then
    exit
  end if
  pACounter = pACounter + 1
  if pACounter > 5 then
    pACounter = 0
    pState = 1
    sprite(pAntChannel).member = pSpriteName & "_" & string(pDirection) & "_1"
    setAntDirection(me, pDirection)
  end if
end

on doDyeSequence me
end

on doGetsHurt me
end

on setReadyTaLaunch me
  pReadyTaLaunch = 1
end

on setDaPath me, thePath
  pDaPath = thePath
  pPathFind = 1
  pCurrentNode = 1
end

on EnemyShot me, targetX, targetY, bDistance
  case gCurrentLevel of
    1:
      targetX = targetX + (random(60) - 30)
      targetY = targetY + (random(60) - 30)
      bDistance = bDistance + (random(30) - 15)
    2:
      targetX = targetX + (random(30) - 15)
      targetY = targetY + (random(30) - 15)
      bDistance = bDistance + (random(15) - 7)
    3:
      targetX = targetX + (random(10) - 5)
      targetY = targetY + (random(10) - 5)
      bDistance = bDistance + (random(10) - 5)
  end case
  bType = 2
  if pBCounter = 0 then
    pReadyTaLaunch = 0
    aChannel = 70
    found = 0
    repeat while found = 0
      if sprite(aChannel).puppet = 1 then
        aChannel = aChannel + 1
        next repeat
      end if
      found = 1
    end repeat
    puppetSound(2, "enemy throw")
    append(gBombList, new(script("BombScript"), pPositionX, pPositionY, bDistance, 10, bType, aChannel, pAntChannel, targetX, targetY))
    aAngle = gBombList[count(gBombList)].getAngle()
    if (aAngle >= 22) and (aAngle < 67) then
      setAntDirection(me, 8)
    else
      if (aAngle >= 67) and (aAngle < 112) then
        setAntDirection(me, 7)
      else
        if (aAngle >= 112) and (aAngle < 157) then
          setAntDirection(me, 6)
        else
          if (aAngle >= 157) and (aAngle < 202) then
            setAntDirection(me, 5)
          else
            if (aAngle >= 202) and (aAngle < 247) then
              setAntDirection(me, 4)
            else
              if (aAngle >= 247) and (aAngle < 292) then
                setAntDirection(me, 3)
              else
                if (aAngle >= 292) and (aAngle < 337) then
                  setAntDirection(me, 2)
                else
                  setAntDirection(me, 1)
                end if
              end if
            end if
          end if
        end if
      end if
    end if
    sprite(pAntChannel).member = pSpriteName & "Throwing" & "_" & pDirection & "_2"
    pState = 2
    pACounter = 0
    repeat with counter = 1 to count(gBombList)
      if gBombList[counter].pState = 3 then
        deleteAt(gBombList, counter)
      end if
    end repeat
  end if
  pBCounter = pBCounter + 1
  if pBCounter > 5 then
    pBCounter = 0
    pState = 2
    sprite(pAntChannel).member = pSpriteName & "_" & string(pDirection) & "_1"
    setAntDirection(me, pDirection)
  end if
end
